org.apache.tinkerpop.gremlin.process.computer.ranking.pagerank

## Class PageRankVertexProgram

- java.lang.Object
- - org.apache.tinkerpop.gremlin.process.computer.ranking.pagerank.PageRankVertexProgram

- All Implemented Interfaces:
    Cloneable, VertexProgram<Double>

      public class PageRankVertexProgram
      extends Object
      implements VertexProgram<Double>

  Author:
    Marko A. Rodriguez (http://markorodriguez.com)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PageRankVertexProgram.Builder`

    - ### Nested classes/interfaces inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VertexProgram.Features`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `PAGE_RANK`

    - ### Fields inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `VERTEX_PROGRAM`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static PageRankVertexProgram.Builder` | `build()`
    `PageRankVertexProgram` | `clone()` When multiple workers on a single machine need VertexProgram instances, it is possible to use clone.
    `void` | `execute(Vertex vertex, Messenger<Double> messenger, Memory memory)` This method denotes the main body of the computation and is executed on each vertex in the graph.
    `VertexProgram.Features` | `getFeatures()`
    `Set<MemoryComputeKey>` | `getMemoryComputeKeys()` The `Memory` keys that will be used during the computation.
    `Optional<MessageCombiner<Double>>` | `getMessageCombiner()` Combine the messages in route to a particular vertex.
    `Set<MessageScope>` | `getMessageScopes(Memory memory)` This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program.
    `GraphComputer.Persist` | `getPreferredPersist()`
    `GraphComputer.ResultGraph` | `getPreferredResultGraph()`
    `Set<VertexComputeKey>` | `getVertexComputeKeys()` The `Element` properties that will be mutated during the computation.
    `void` | `loadState(Graph graph, org.apache.commons.configuration2.Configuration configuration)` When it is necessary to load the state of the VertexProgram, this method is called.
    `void` | `setup(Memory memory)` The method is called at the beginning of the computation.
    `void` | `storeState(org.apache.commons.configuration2.Configuration configuration)` When it is necessary to store the state of the VertexProgram, this method is called.
    `boolean` | `terminate(Memory memory)` The method is called at the end of each iteration to determine if the computation is complete.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.tinkerpop.gremlin.process.computer.VertexProgram

      `createVertexProgram, getMapReducers, getTraverserRequirements, workerIterationEnd, workerIterationStart`

- - ### Field Detail

    - #### PAGE_RANK

          public static final String PAGE_RANK

      See Also:
        Constant Field Values

  - ### Method Detail

    - #### loadState

          public void loadState(Graph graph,
                                org.apache.commons.configuration2.Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to load the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is loaded is simply the instance state, not any processed data.
      Specified by:
        `loadState` in interface `VertexProgram<Double>`
      Parameters:
        `graph` - the graph that the VertexProgram will run against
        `configuration` - the configuration to load the state of the VertexProgram from.

    - #### storeState

          public void storeState(org.apache.commons.configuration2.Configuration configuration)

      Description copied from interface: `VertexProgram`
      When it is necessary to store the state of the VertexProgram, this method is called. This is typically required when the VertexProgram needs to be serialized to another machine. Note that what is stored is simply the instance/configuration state, not any processed data. The default implementation provided simply stores the VertexProgram class name for reflective reconstruction. It is typically a good idea to VertexProgram.super.storeState().
      Specified by:
        `storeState` in interface `VertexProgram<Double>`
      Parameters:
        `configuration` - the configuration to store the state of the VertexProgram in.

    - #### getPreferredResultGraph

          public GraphComputer.ResultGraph getPreferredResultGraph()

      Specified by:
        `getPreferredResultGraph` in interface `VertexProgram<Double>`

    - #### getPreferredPersist

          public GraphComputer.Persist getPreferredPersist()

      Specified by:
        `getPreferredPersist` in interface `VertexProgram<Double>`

    - #### getVertexComputeKeys

          public Set<VertexComputeKey> getVertexComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Element` properties that will be mutated during the computation. All properties in the graph are readable, but only the keys specified here are writable. The default is an empty set.
      Specified by:
        `getVertexComputeKeys` in interface `VertexProgram<Double>`
      Returns:
        the set of element keys that will be mutated during the vertex program's execution

    - #### getMessageCombiner

          public Optional<MessageCombiner<Double>> getMessageCombiner()

      Description copied from interface: `VertexProgram`
      Combine the messages in route to a particular vertex. Useful to reduce the amount of data transmitted over the wire. For example, instead of sending two objects that will ultimately be merged at the vertex destination, merge/combine into one and send that object. If no message combiner is provider, then no messages will be combined. Furthermore, it is not guaranteed the all messages in route to the vertex will be combined and thus, combiner-state should not be used. The result of the vertex program algorithm should be the same regardless of whether message combining is executed or not.
      Specified by:
        `getMessageCombiner` in interface `VertexProgram<Double>`
      Returns:
        A optional denoting whether or not their is a message combine associated with the vertex program.

    - #### getMemoryComputeKeys

          public Set<MemoryComputeKey> getMemoryComputeKeys()

      Description copied from interface: `VertexProgram`
      The `Memory` keys that will be used during the computation. These are the only keys that can be read or written throughout the life of the `GraphComputer`. The default is an empty set.
      Specified by:
        `getMemoryComputeKeys` in interface `VertexProgram<Double>`
      Returns:
        the set of memory keys that will be read/written

    - #### getMessageScopes

          public Set<MessageScope> getMessageScopes(Memory memory)

      Description copied from interface: `VertexProgram`
      This method returns all the `MessageScope` possibilities for a particular iteration of the vertex program. The returned messages scopes are the scopes that will be used to send messages during the stated iteration. It is not a requirement that all stated messages scopes be used, just that it is possible that they be used during the iteration.
      Specified by:
        `getMessageScopes` in interface `VertexProgram<Double>`
      Parameters:
        `memory` - an immutable form of the `Memory`
      Returns:
        all possible message scopes during said vertex program iteration

    - #### clone

          public PageRankVertexProgram clone()

      Description copied from interface: `VertexProgram`
      When multiple workers on a single machine need VertexProgram instances, it is possible to use clone. This will provide a speedier way of generating instances, over the `VertexProgram.storeState(org.apache.commons.configuration2.Configuration)` and `VertexProgram.loadState(org.apache.tinkerpop.gremlin.structure.Graph, org.apache.commons.configuration2.Configuration)` model. The default implementation simply returns the object as it assumes that the VertexProgram instance is a stateless singleton.
      Specified by:
        `clone` in interface `VertexProgram<Double>`
      Overrides:
        `clone` in class `Object`
      Returns:
        A clone of the VertexProgram object

    - #### setup

          public void setup(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the beginning of the computation. The method is global to the `GraphComputer` and as such, is not called for each vertex. During this stage, the `Memory` should be initialized to to its "start state."
      Specified by:
        `setup` in interface `VertexProgram<Double>`
      Parameters:
        `memory` - The global memory of the GraphComputer

    - #### execute

          public void execute(Vertex vertex,
                              Messenger<Double> messenger,
                              Memory memory)

      Description copied from interface: `VertexProgram`
      This method denotes the main body of the computation and is executed on each vertex in the graph. This method is logically executed in parallel on all vertices in the graph. When the `Memory` is read, it is according to the aggregated state yielded in the previous iteration. When the `Memory` is written, the data will be aggregated at the end of the iteration for reading in the next iteration.
      Specified by:
        `execute` in interface `VertexProgram<Double>`
      Parameters:
        `vertex` - the `Vertex` to execute the `VertexProgram` on
        `messenger` - the messenger that moves data between vertices
        `memory` - the shared state between all vertices in the computation

    - #### terminate

          public boolean terminate(Memory memory)

      Description copied from interface: `VertexProgram`
      The method is called at the end of each iteration to determine if the computation is complete. The method is global to the `GraphComputer` and as such, is not called for each `Vertex`. The `Memory` maintains the aggregated data from the last execute() iteration.
      Specified by:
        `terminate` in interface `VertexProgram<Double>`
      Parameters:
        `memory` - The global memory of the `GraphComputer`
      Returns:
        whether or not to halt the computation

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### build

          public static PageRankVertexProgram.Builder build()

    - #### getFeatures

          public VertexProgram.Features getFeatures()

      Specified by:
        `getFeatures` in interface `VertexProgram<Double>`

Copyright © 2013–2022 Apache Software Foundation. All rights reserved.